(
global softwareVersion = "3.04 - 190104"
	
------------------------------------------------------------------------------------------------------------------------------------------------------------------------ UI rollout control
global VFBTabs
try(destroyDialog VFBTabs)catch()
local LastSubRollout = 1
VFBTabs_Rollouts = #(#("Stills",#(VFBTabsRollout01)),#("Animations",#(VFBTabsRollout02)))
global SimpleDeadlineSubmitter_Rollout
try(destroyDialog SimpleDeadlineSubmitter_Rollout)catch()
global SubRolloutStills_Rollout
global SubRolloutAnimations_Rollout
global SubRolloutBatchRender
	global SubRolloutBETA_Rollout
	
---------------------------------------------------------------------------------------------------------------------------------------------------------------------- Setting up the Deadline files
global SMTDSettings
global SMTDFunctions
global SMTDPaths
local theNetworkRoot = @"\\VRAYSERVER2\DeadlineRepository8"
local remoteScript = theNetworkRoot + @"\submission\3dsmax\main\SubmitMaxToDeadline_Functions.ms"
local localScript = getDir #userscripts + @"\SubmitMaxToDeadline_Functions.ms"
if SMTDFunctions == undefined do
(
	deleteFile localScript
	copyFile remoteScript localScript
	fileIn localScript
)
setIniSetting SMTDPaths.InIFile "RenderingOptions"  "GammaCorrection" ((SMTDSettings.GammaCorrection = true) as string)
setIniSetting SMTDPaths.InIFile "RenderingOptions"  "GammaOutput" ( (SMTDSettings.GammaOutput= "2.2") as string)
setIniSetting SMTDPaths.InIFile "RenderingOptions"  "GammaInput" ( (SMTDSettings.GammaInput= "2.2") as string)
SMTDFunctions.loadSettings()

------------------------------------------------------------------------------------------------------------------------------------------------------------------------ Set up global files
-- Set a variable that contains the UNC path where the file is saved
local UncMaxFilePath = pathConfig.convertPathToUnc maxFilePath
local cameraList=#()
local ImgOutputName
local stillBatchName=""
local dnc_report
local outputPath = UncMaxFilePath
local pathFilter = filterString UncMaxFilePath @"\"
local projectName = ""
local isProdProject = false
local today_date
local today_month
local today_year
local folder_year = undefined
local listYears=#("2014","2015","2016","2017","2018", "2019")
local maxPx=1500
local list_extentions=#(".jpg",".jpeg",".tif",".tiff")
local ScriptTif16= "Z:\scripts\Deadline\\tifsave.ms"
local settingsDBR
local PathStill 
local PathAnimation 
local Output_Path
local SchedulePm = true
local theHourSchedule = "19:00"
local renderMsg = ""
global RenderMode="Still" -- Set default when opening script
global EngineModes=#("LCBF") --Removed LCIR, LCMove "CACA"
global EngineMode="LCBF" -- Set default when opening script
global CoronaEngineMode ="direct"
global Tiled=false
local nThFrames = 25
local nbr_spawn = 10
local IM_path=""
local LC_path=""
local jobNameRender,jobNameLC,jobNameIM,jobName,jobNameUHD
local subFolderMain
local todayDate
local engine

local SubRolloutEngineAnimation_Rollout

-- Sets the project name variable and check if the file is saved in production project file 
fn getProjectName=
(
-- 	Break the filepath in order to check specific parts of it
	pathFilter = filterString UncMaxFilePath @"\"
-- 	We initiate the isProdProject to false
	
	isProdProject = false
-- 	We check if the folder path has more than 2 subfolder and that the second one is WORK. This means that the file belongs to a specific project so it becomes a production project so isProdProject becomes true
-- 	If not, the project name becomes the max file name
	if((pathFilter.count > 2) and ((toLower pathFilter[2]) == "work")) then
	(
		if ((findItem listYears pathFilter[3])!=0) then
			(
				projectName = pathFilter[4]
				folder_year = pathFilter[3]
			) --take 4rd folder
			else
			(
				projectName = pathFilter[3]
			)
		isProdProject = true
	)else
	(
		projectName = maxFileName
		-- Removes the .max from the filename
		projectName = getFilenameFile projectName
	)
-- 	We initiate the batch name variable to be the projectName
	 return projectName
)

fn getDateToday =
(
	-- We create a temporary file in order to get the date from it, Then we remove the file
	tempFile = (SMTDPaths.TempDir+ "_TempDate.txt")
	deleteFile tempFile 
	theFile = createFile tempFile
	format "Date\n" to:theFile
	close theFile
	theDate = getFileModDate tempFile 

	-- We create the date with the right format
	deleteFile tempFile 
	theFS = filterString theDate  "/ :"
	today_date= theFS[2] 
	today_month = theFS[1]
	today_year= theFS[3] 


	if (today_month.count==1)then today_month = "0" + today_month
	if (today_date.count==1)then today_date = "0" + today_date

	--Get today's date
	today_year_duo =substring  today_year 3 2
	return (today_year_duo + today_month + today_date)
)


-- Remove the special characters in the output name
fn fix_output_char outpath=
(
illegalChars = "\/:*?\"<>|"
ReplaceChar = "_"

for i = 1 to illegalChars.count do
(
	if (substituteString != undefined) then
	(
		for n = 1 to outpath.count do (outpath = substituteString outpath illegalChars[i] ReplaceChar)
	)
)

return outpath

)


-- Initiate the ListView for report. It can also be ued if you just want to clear the listview
fn initReportWindow =
(
	local lv=dnc_report
	local layout_def = #(#("Time Stamp",40), #("Message",200))
	dnc_report.Clear()
	dnc_report.backColor = (dotNetClass "System.Drawing.Color").fromARGB 90 90 90
	dnc_report.View = (dotNetClass "System.Windows.Forms.View").Details
	dnc_report.gridLines = false 
	dnc_report.fullRowSelect = true
	dnc_report.checkboxes = false
	dnc_report.hideSelection = true
	dnc_report.HeaderStyle = dnc_report.HeaderStyle.None
	for i in layout_def do dnc_report.Columns.add i[1] i[2]		
)
		
-- Function to add stuff to the listView		
fn Ui_report txt clearLv:false LogFileOnly:false AddTimeStamp:true color:color addText:undefined =
(
	if clearLv do initReportWindow()
	local theRange = #()
-- 	Set the colors of the ListView
	local blackColor = (dotNetClass "System.Drawing.Color").fromARGB 255 255 255
	local redColor = (dotNetClass "System.Drawing.Color").fromARGB 255 128 128
	local orangeColor = (dotNetClass "System.Drawing.Color").fromARGB 255 180 50
	local greenColor = (dotNetClass "System.Drawing.Color").fromARGB 128 255 128
	local blueColor = (dotNetClass "System.Drawing.Color").fromARGB 192 220 255
	
	local lineCount = 0
	local foreColor = blackColor	


	case color of
	(
		default: (
		foreColor = blackColor
		)
		("blue"): (
			foreColor = blueColor
		)
		("red"): (
			foreColor = redColor
		)
		("orange"): (
			foreColor = orangeColor
		)
		("green"): (
			foreColor = greenColor
		)
	)
	
-- 	If the timestamp is set to true then we add the timestamp.
-- 	If addText is defined then we add the addText to the left of the column to replace the timeStamp
	local leftColumn = (if AddTimeStamp then localtime else "") 
	if (addText!=undefined) then leftColumn = addText

-- 	We create the line to add to the list with the right color and add it to the listView
	local li = dotNetObject "System.Windows.Forms.ListViewItem" leftColumn
	li.forecolor = foreColor
	local subLi = li.SubItems.add txt
	append theRange li
	dnc_report.Items.AddRange theRange
	dnc_report.Items.Item[dnc_report.Items.Count-1].EnsureVisible()
-- 	Making sure that there are no scrollbars
	local autoRes = dotNetClass "System.Windows.Forms.ColumnHeaderAutoResizeStyle"
	dnc_report.AutoResizeColumns autoRes.ColumnContent
	try(windows.processPostedMessages())catch()
			
-- I'm not sure this is useful for us so I commented it hopfully it doesn't brake anything
-- 	if AddTimeStamp then
-- 		try( format "[%] : %\n" (getTimeString()) txt to:SMTD_todaysLogFile)catch()			
-- 	else	
-- 		try( format "%\n" txt to:SMTD_todaysLogFile)catch()			
)	

-- Function to submit stuff for animations to Deadline
fn SubmitToDeadline jobName dependant SingleBlade dbr:false batchGrouping:true subFolder:undefined isPrepass:false=
(

	if (engine=="vray") then
	(
		if(not isPrepass) then
		(
			if (SimpleDeadlineSubmitter_Rollout.chk_beauty_tif.checked)then
				renderers.current.output_splitgbuffer = true
			else
				renderers.current.output_splitgbuffer = false
			
			if (SimpleDeadlineSubmitter_Rollout.chk_beauty_exr.checked) then
				renderers.current.output_saveRawFile = true
			else
				renderers.current.output_saveRawFile = false
		)
	)
	if (engine=="corona") then
	(
		if(not isPrepass) then
		(
			rendSaveFile = true
			if (SimpleDeadlineSubmitter_Rollout.chk_beauty_tif.checked)then
			(
				local tempOut = rendOutputFilename
				tempOut = substring tempOut 1 (tempOut.count - 4)
				rendOutputFilename = tempOut + ".tif"
			)
		)
		else
		(
			rendSaveFile = false
		)
	)
	
-- 	Set up all of the Deadline loading things
	local maxFileToSubmit = SMTDPaths.tempdir + maxFileName
	SMTDFunctions.SaveMaxFileCopy maxFileToSubmit
	local SubmitInfoFile = SMTDPaths.Tempdir + "max_submit_info.job"
	local JobInfoFile = SMTDPaths.Tempdir+ "max_job_info.job"
	
	if (SingleBlade) then
	(
		setIniSetting SMTDPaths.InIFile "JobSettings"  "LimitEnabled" ( (SMTDSettings.LimitEnabled = true) as string)
		setIniSetting SMTDPaths.InIFile "JobSettings"  "MachineLimit" ( (SMTDSettings.machineLimit = "1") as string)
	)
	else
	(
		if(SimpleDeadlineSubmitter_Rollout.chk_simult_blades.checked) then
		(
			setIniSetting SMTDPaths.InIFile "JobSettings"  "LimitEnabled" ( (SMTDSettings.LimitEnabled = true) as string)
			setIniSetting SMTDPaths.InIFile "JobSettings"  "MachineLimit" ( (SMTDSettings.machineLimit = SimpleDeadlineSubmitter_Rollout.spn_simult_blades.value) as string)
		)
		else
		(
			setIniSetting SMTDPaths.InIFile "JobSettings"  "LimitEnabled" ( (SMTDSettings.LimitEnabled = false) as string)
			setIniSetting SMTDPaths.InIFile "JobSettings"  "MachineLimit" ( (SMTDSettings.machineLimit = "0") as string)
		)
	)

	
	SMTDSettings.JobName = jobName
	SMTDSettings.SubmitAsDependent = dependant
	
-- 	I'm not exactly sure how that works as Graham made it and I didn't bother changing it
-- 	I think it basically just make the new job dependant on the old one
	if(dependant) do
	(
		local renderMsg = SMTDFunctions.getRenderMessage()
		SMTDFunctions.getJobIDFromMessage renderMsg
		SMTDFunctions.CollectJobs()
		SMTDSettings.DependOnPreviousJobMode = 0 --#none
	)
	
-- 	Prepare the job to be sent to Deadline
	if (batchGrouping==true) then
	(
		JobBatchName=""
		SMTDFunctions.CreateSubmitInfoFile SubmitInfoFile batchName:SimpleDeadlineSubmitter_Rollout.edt_jobname.text 
	)
	else
		SMTDFunctions.CreateSubmitInfoFile SubmitInfoFile
	
		SMTDFunctions.CreateJobInfoFile JobInfoFile
		

-- 	Rewrite some stuff for dependency purposes and set restartRenderer to 0
	fs = openFile submitInfoFile mode:"r+"
	if(dependant) do
	(
		--make this job dependant on last job.. write directly to settings file
		format "JobDependencies=%\n" 	SMTDSettings.DeadlineSubmissionLastJobID  to:fs
	)
	format "RestartRendererMode=%\n" 	0  to:fs
	close fs
	
-- 	Sends the job and return if it worked or not
	local initialArgs = "\""+SubmitInfoFile+"\" \""+JobInfoFile+"\" \""+maxFileToSubmit+"\" "
	return SMTDFunctions.waitForCommandToComplete initialArgs SMTDSettings.TimeoutSubmission
	
)

-- Function to submit Stills to Deadline
fn SubmitToDeadline_Rdr JobName isBatch:false=
(
	if (engine=="vray") then
	(
					cmdEnabled = true
				SMTDSettings.DBRUse3dsCmd = true
			setIniSetting SMTDPaths.IniFile "DBROptions"  "DBRUse3dsCmd" ((SMTDSettings.DBRUse3dsCmd = true) as string)
			
		if (SimpleDeadlineSubmitter_Rollout.chk_beauty_tif.checked)then
		(
			 renderers.current.output_splitgbuffer = true
		)
			else
			renderers.current.output_splitgbuffer = false
		
		if (SimpleDeadlineSubmitter_Rollout.chk_beauty_exr.checked) then
			renderers.current.output_saveRawFile = true
		else
			renderers.current.output_saveRawFile = false

	-- 	Render final image
		renderers.current.options_dontRenderImage = false
		
		if (nbr_spawn>0) then
		(
			-- Set the number of blades that are going to render the image
			SMTDSettings.DBR = true
			renderers.current.system_distributedRender = true
			setIniSetting SMTDPaths.InIFile "DBROptions"  "DBRServers" ((SMTDSettings.DBRServers = nbr_spawn) as string)
		)
		else
		(
			renderers.current.system_distributedRender = false
			SMTDSettings.DBR = false
		)
	)
	if (engine=="corona") then
	(
		rendSaveFile = true
		renderers.current.gi_uhdcache_preset =0
		if (SimpleDeadlineSubmitter_Rollout.chk_beauty_tif.checked)then
		(
			local tempOut = rendOutputFilename
			tempOut = substring tempOut 1 (tempOut.count - 4)
			rendOutputFilename = tempOut + ".tif"
		)
		
		if (nbr_spawn>0) then
		(
			renderers.current.dr_enable=true
			SMTDSettings.DBR = true		
			SMTDSettings.DBRUse3dsCmd = false
			cmdEnabled  = false
			setIniSetting SMTDPaths.IniFile "DBROptions"  "DBRUse3dsCmd" ((SMTDSettings.DBRUse3dsCmd = false) as string)
			setIniSetting SMTDPaths.InIFile "DBROptions"  "DBRServers" ((SMTDSettings.DBRServers = nbr_spawn) as string)
			)
	)
	
-- 	Prepare the file to be sent to Deadline
	local maxFileToSubmit = SMTDPaths.tempdir + maxFileName
	SMTDFunctions.SaveMaxFileCopy maxFileToSubmit
	local SubmitInfoFile = SMTDPaths.Tempdir + "max_submit_info.job" 
	local JobInfoFile = SMTDPaths.Tempdir+ "max_job_info.job"
	SMTDSettings.JobName = jobName
	

			
-- 			setIniSetting SMTDPaths.InIFile "Scripts"  "RunPreLoadScript" ((SMTDSettings.RunPreLoadScript = true) as string)
-- 		setIniSetting SMTDPaths.InIFile "Scripts"  "PreLoadScriptFile" ((SMTDSettings.PreLoadScriptFile = ScriptTif16) as string)
-- 		print ScriptTif16
	
-- 	Makes sure that the job is not limited to a single machine
	if(SimpleDeadlineSubmitter_Rollout.chk_simult_blades.checked) then
	(
		setIniSetting SMTDPaths.InIFile "JobSettings"  "LimitEnabled" ( (SMTDSettings.LimitEnabled = true) as string)
		setIniSetting SMTDPaths.InIFile "JobSettings"  "MachineLimit" ( (SMTDSettings.machineLimit = SimpleDeadlineSubmitter_Rollout.spn_simult_blades.value) as string)
	)
	else
	(
		setIniSetting SMTDPaths.InIFile "JobSettings"  "LimitEnabled" ( (SMTDSettings.LimitEnabled = false) as string)
		setIniSetting SMTDPaths.InIFile "JobSettings"  "MachineLimit" ( (SMTDSettings.machineLimit = "0") as string)
	)

	
	
-- 	If the file is set to be set as a batch file than we prep the file with a batchname, if not we don't
	if (isBatch) then 
	(
		SMTDFunctions.CreateSubmitInfoFile SubmitInfoFile batchName:stillBatchName
	)
	else
	(
		SMTDFunctions.CreateSubmitInfoFile SubmitInfoFile		
	)
	
	SMTDFunctions.CreateJobInfoFile JobInfoFile
		
-- 	Sends the job and return if it worked or not
	local initialArgs = "\""+SubmitInfoFile+"\" \""+JobInfoFile+"\" \""+maxFileToSubmit+"\" "
	return SMTDFunctions.waitForCommandToComplete initialArgs SMTDSettings.TimeoutSubmission
)

-- Prepare light cache for animation
fn PrepareLightCacheJob_Anim =
	(	

		
		--separate render channels
		renderers.current.output_splitgbuffer = false
		--Time Output
		rendTimeType = 1 --single frame
		
		-- Dont render final image
		renderers.current.options_dontRenderImage = true
		renderers.current.gi_primary_type = 3 --light cache

		--Secondary engine
		renderers.current.gi_secondary_type = 3 --light cache
		renderers.current.lightcache_mode = 0 -- single
		renderers.current.lightcache_multipleViews = true -- turn on use camera path


		renderers.current.lightcache_loadFileName = LC_path
		renderers.current.saveLightCache LC_path
		
		renderers.current.lightcache_dontDelete = true
		renderers.current.lightcache_autoSave = true
		
		renderers.current.lightcache_autoSaveFileName = LC_path


		
	)

-- Prepare irradiance map for animation, It also prepare the light cache for the 2nd phase of the prepass
	fn PrepareIrradienceMapJob NthFrame mode=
	(

		rendTimeType = 2 -- Active Time Segment
		rendNthFrame = NthFrame
		
		-- Dont render final image
		renderers.current.options_dontRenderImage = true
		
		--Primary engine
		renderers.current.gi_primary_type = 0 --irradiance map
		--Secondary engine
		renderers.current.gi_secondary_type = 3 --light cache


		renderers.current.adv_irradmap_mode = mode 



		--reset max to update path
		renderers.current.saveIrradianceMap(IM_path)
		renderers.current.adv_irradmap_loadFileName = IM_path
		renderers.current.adv_irradmap_saveFileName = IM_path
		renderers.current.adv_irradmap_dontDelete = true
		renderers.current.adv_irradmap_autoSave = true
		--makeDir (maxFilePath + (getFilenameFile maxfilename) + "AnimationPrepass")
		
		renderers.current.adv_irradmap_autoSaveFileName = IM_path
		
		renderers.current.lightcache_dontDelete = true
		renderers.current.lightcache_autoSave = false
		renderers.current.lightcache_mode = 2 --from file
		renderers.current.lightcache_loadFileName = LC_path
	)

-- Prepare Render for animation. It also prepares the lc and irrmap
	fn PrepareRenderScene irrMode =
	(
		
		rendTimeType = 2 -- Active Time Segment
		rendNthFrame = 1
		
		--seporate render channels
		renderers.current.output_splitgbuffer = true

		renderers.current.options_dontRenderImage = false
		
		
		
		renderers.current.gi_primary_type = 0 --Irradience map
		renderers.current.adv_irradmap_mode = irrMode --From file
		renderers.current.adv_irradmap_loadFileName = IM_path
		renderers.current.output_splitfilename = SimpleDeadlineSubmitter_Rollout.edt_OutputFile.text
		
		--messageBox renderers.current.output_splitfilename
		--Primary engine

		--Secondary engine
		renderers.current.gi_secondary_type = 3 --light cache
		renderers.current.lightcache_mode = 2 -- From File
		renderers.current.lightcache_loadFileName = LC_path
		
	)

-- Prepare brute force render for animation
	fn PrepareRenderScene_BF =
	(

		
		rendTimeType = 2 -- Active Time Segment
		rendNthFrame = 1
		
		--seporate render channels
		renderers.current.output_splitgbuffer = true

		renderers.current.options_dontRenderImage = false
		
		renderers.current.gi_primary_type = 2 --Brute force
		
		--messageBox renderers.current.output_splitfilename
		--Primary engine

		--Secondary engine
		renderers.current.gi_secondary_type = 3 --light cache
		renderers.current.lightcache_mode = 2 -- From File
		renderers.current.lightcache_loadFileName = LC_path
		

	)

-- Prepare brute force render for animation
	fn PrepareRenderScene_NOGI =
	(

		
		rendTimeType = 2 -- Active Time Segment
		rendNthFrame = 1
		
		--seporate render channels
		renderers.current.output_splitgbuffer = true

		renderers.current.options_dontRenderImage = false
		

	)

-- Clean up Vray after the render
	fn CleanUpSettings =
	(

		if (engine=="vray") then
		(

			renderers.current.output_saveRawFile = false
			renderers.current.output_splitgbuffer = false
			--set GI air and lightcache mode back to default and clear autosave setting
			renderers.current.adv_irradmap_autoSave = false
			renderers.current.lightcache_autoSave = false
			
			renderers.current.gi_primary_type = 2       	--"CACA"
			renderers.current.gi_secondary_type = 3		--"CACA"
			
		-- 	renderers.current.adv_irradmap_mode = 0 --single frame "CACA"
		-- 	renderers.current.lightcache_mode = 0 --single frame "CACA"
			 renderers.current.system_distributedRender = settingsDBR
				renderers.current.lightcache_mode = 0
		)
		if (engine=="corona") then
		(
			renderers.current.dr_enable=false
			renderers.current.gi_uhdCache_precalcMode =0
		)
		rendTimeType = 1
		rendNthFrame = 1
		rendSaveFile = false
	)


-- Change the schedule of the render. The render will only start rendering when it reaches the time set up (7pm)
fn change_schedule theState =
(

	if (theState) then
	(
		timetoSend = today_date + "/" + today_month + "/" + today_year + " " + theHourSchedule
		SMTDSettings.ScheduledStartDateTime =  timetoSend
		SMTDSettings.ScheduledType =  #Once
	)
	else
	(
		SMTDSettings.ScheduledType =  #None
	)
)

fn getKeyFrames obj = (
	local arrayOfKeys = #()
	local lowestKey = 0
	local highestKey = 1
	local objs = #()
	
	-- Add the obj to the objs array, and it's target if it has one
	append objs obj
	if obj.target != undefined then append objs obj.target
		
	-- Check all objs associated with the obj (targets, etc)
	for o in objs do (
		-- Position Controller Keys
		if isProperty o #position then (
			if o.position.controller.keys.count > 0 then (
				append arrayOfKeys ((o.position.controller.keys[1].time as integer)/TicksPerFrame)
				append arrayOfKeys ((o.position.controller.keys[o.position.controller.keys.count].time as integer)/TicksPerFrame)
			)
		)
		
		-- Rotation Controller Keys
		if isProperty o #rotation then (
			if o.rotation.controller.keys.count > 0 then (
				append arrayOfKeys ((o.rotation.controller.keys[1].time as integer)/TicksPerFrame)
				append arrayOfKeys ((o.rotation.controller.keys[o.rotation.controller.keys.count].time as integer)/TicksPerFrame)
			)
		)
		
		-- Scale Controller Keys
		if isProperty o #scale then (
			if o.scale.controller.keys.count > 0 then (
				append arrayOfKeys ((o.scale.controller.keys[1].time as integer)/TicksPerFrame)
				append arrayOfKeys ((o.scale.controller.keys[o.scale.controller.keys.count].time as integer)/TicksPerFrame)		
			)
		)
		
		if (classof o.position.controller) == Path_Constraint then (
			if o.position.controller.percent.controller.keys.count > 0 then (
				append arrayOfKeys ((o.position.controller.percent.controller.keys[1].time as integer)/TicksPerFrame)
				append arrayOfKeys ((o.position.controller.percent.controller.keys[o.position.controller.percent.controller.keys.count].time as integer)/TicksPerFrame)
			)
		)
	)	-- end for o in objs
	
	sort arrayOfKeys
	
	if arrayOfKeys.count >= 2 then (
		#(arrayOfKeys[1], arrayOfKeys[arrayOfKeys.count])
	) else (
		#(0,1)
	)
)




fn resizeViewport cameraName Imagepx=
(
	AspectRatio = (getUserProp cameraName "AR")
	print AspectRatio
	if AspectRatio != undefined then 
	(
		if AspectRatio >= 1 then 
			renderheight = (RenderWidth = Imagepx)/(AspectRatio  as float)
		else
			renderwidth = (RenderHeight = Imagepx)/(1/(AspectRatio  as float))
		renderSceneDialog.update()
	)
)








-- Set the output paths
fn updateJobNamefromOutputPath  = 
(
outputFile = getFilenameFile SimpleDeadlineSubmitter_Rollout.edt_OutputFile.text
------------------------------------hyper caca
		SimpleDeadlineSubmitter_Rollout.edt_jobname.text = projectName + "_" + outputFile
	
	if ((subFolderMain!=undefined)  and  (subFolderMain!="")) then 
	(
		SimpleDeadlineSubmitter_Rollout.edt_jobname.text = SimpleDeadlineSubmitter_Rollout.edt_jobname.text + "_" + subFolderMain
		
	)

	
	
	
	
)
 
function setOutputPath =
 (

	Output_Path=SimpleDeadlineSubmitter_Rollout.edt_OutputFile.text

	JobName = SimpleDeadlineSubmitter_Rollout.edt_jobname.text 
	outputPath = getFilenamePath Output_Path
	 outputFile = getFilenameFile Output_Path
	
	 --Karan output text here	
	ss = substring Output_Path 1 (Output_Path.count-4)
	jobNameRender = JobName + "_3_Render"
	if (engine=="vray") then
	(
			 if (SimpleDeadlineSubmitter_Rollout.chk_beauty_tif.checked) then 
	 	renderers.current.output_splitRGB = true
		
		IM_path = outputPath + outputFile + "_IR_.vrmap" 
		LC_path = outputPath + outputFile + "_LC_.vrlmap"
		
		jobNameLC = JobName + "_1_LC"
		jobNameIM =JobName + "_2_IM"
		renderers.current.output_splitfilename = Output_Path
		renderers.current.output_rawFileName =ss + ".exr"
	)
	if (engine=="corona") then
	(
		jobNameUHD = JobName + "_1_UHD"
		rendOutputFilename = ss + ".cxr"
	)
	
	
	
	)


--check if value is a number 
fn isNumeric str =
(
    try
    (
        (str as integer) != undefined
    )
    catch(false)
)


-- BETA rollout
rollout  SubRolloutBETA_Rollout "BETA"
(
	checkbox chk_LC_Local "Render Light Cache Locally" align:#left checked:false
	edittext edt_LC_Local_Output "" fieldwidth:430  align:#right
-- 	foutre
	
	

)	
-- Update the output path and the job name
fn update_output_path_Job_Name=
(
				


	if(viewport.getCamera() != undefined) then
	(
-- 		If we render from a camera we set the output path to the camera name minus the camera range and any special character
		ImgOutputName = (viewport.getCamera()).name
		ImgOutputName = fix_output_char ImgOutputName

		--SimpleDeadlineSubmitter_Rollout.edt_jobname.text += "_" + ImgOutputName
	)
	else
	(
-- 		If we don't render from a cammera the output name will be set to Perspective
		ImgOutputName = "Perspective"
	)

-- 	If it's a production project (this means that the file is saved on the Y drive inside a project folder)
	if (isProdProject) then
	(

		
		
	 
		if (RenderMode == "Animation") do
		(
			Output_Path = PathAnimation + ImgOutputName + "\\" + ImgOutputName + ".tif"
			SimpleDeadlineSubmitter_Rollout.edt_OutputFile.text = Output_Path
			
		)
		if (RenderMode == "Still") do
		(
			Output_Path = PathStill + ImgOutputName + ".tif"		

			SimpleDeadlineSubmitter_Rollout.edt_OutputFile.text = Output_Path
			
		)
	)else
	(
			Output_Path = UncMaxFilePath + "\\" +ImgOutputName + ".tif"
			SimpleDeadlineSubmitter_Rollout.edt_OutputFile.text = Output_Path
	)
	
-- print Output_Path
 	SubRolloutBETA_Rollout.edt_LC_Local_Output.text= (substring Output_Path 1 (Output_Path.count-4 )) + ".vrlmap"
	
		 
--foutre	
	
	
	
	
	
	
	
	
	
	
	updateJobNamefromOutputPath()
)

fn setBaseOutputPath =
(
			year =""
		if (folder_year!=undefined) then year= folder_year +"\\"
	
	if ((subFolderMain!=undefined) and  (subFolderMain!="")) then
	(
		subFolder= subFolderMain
		if(SimpleDeadlineSubmitter_Rollout.SubFolderPlace.state==0 or SimpleDeadlineSubmitter_Rollout.SubFolderPlace.state==1) then
		(
			PathStill = "\\\server\work\\"+year + projectName + "\\RENDERS\OUTPUT\\" + subFolderMain + "\\" + todayDate + "\\" 
			PathAnimation = "\\\server\work\\"+year + projectName + "\\ANIMATIONS\OUTPUT\\"  +  subFolderMain + "\\" + todayDate  + "\\"
		)
		if(SimpleDeadlineSubmitter_Rollout.SubFolderPlace.state==2) then
		(
			PathStill = "\\\server\work\\"+year + projectName + "\\RENDERS\OUTPUT\\"  + todayDate + "\\" + subFolderMain + "\\"
			PathAnimation = "\\\server\work\\"+year + projectName + "\\ANIMATIONS\OUTPUT\\"  +  todayDate + "\\" + subFolderMain + "\\"
		)
	)
	else
	(
		PathStill = "\\\server\work\\"+year + projectName + "\\RENDERS\OUTPUT\\"  + todayDate  + "\\"
		PathAnimation = "\\\server\work\\"+year + projectName + "\\ANIMATIONS\OUTPUT\\"  +  todayDate + "\\" 
	)
)



-- Changes the animation frame range from the camera name
fn setAnimationRange2 auto inFrame outFrame=
(
	print "cul"
-- 	To check if the camera has the right format
	local isCamFormat = false
-- 	To check if the view is set to a camera
	local isCam = false
-- 	We change stuff only if the auto frame range is on
	if (auto) then
	(
		if (not viewport.getCamera()==undefined) then
		(
			keyFrames = getKeyFrames (viewport.getCamera())
			inFrame = keyFrames[1]
			outFrame = keyFrames[2]
		)else
		(
			Ui_report "No camera is selected in the viewport... Set frame range from camera name will not work." color:"red"
		)
		--if not isCamFormat and isCam then Ui_report "The camera you selected doesn't have the right name format. Set frame range from camera name will not work." color:"red"
	)
-- 	Set the beginning and end frame
	if ((classof inFrame) == string) then inFrame = (inFrame as integer)
	if ((classof outFrame) == string) then outFrame = (outFrame as integer)
	animationRange = interval inFrame outFrame
	SubRolloutEngineAnimation_Rollout.edt_InFrame.text = inFrame as string
 	SubRolloutEngineAnimation_Rollout.edt_OutFrame.text = outFrame as string
)






-- When you fill the vfb output path for the first time without having saved anything before, for some reasn the file doesn't get saved
-- So we create a jpg, save it and then remove it. It helps the vfb to not act stupid
fn initiate_vfb_save =
(
	bm_filename = sysInfo.tempdir + "tmp.jpg"
	bm=Bitmap 10 10 fileName: bm_filename
	save bm
	close bm
	renderers.current.output_splitbitmap=bm
	deleteFile bm_filename
)

-- Check if the saving path exist. If it doesn't exist it creates it.
-- If it's on the C drive then it will return 2, If the creation of the folder was not possible then it will return 0
fn PathCheck =
(
	currentFolder =  getFilenamePath Output_Path
	tempcurrentFolder = substring currentFolder 1 1
	if(tempcurrentFolder=="C") then
	(
		isFolderOk = 2
	)
	else
	(
		ifFolder = doesfileexist (getFilenamePath Output_Path)
		if (not ifFolder) then 
		(
			isFolderOktemp = makeDir (getFilenamePath Output_Path)
			if (isFolderOktemp) then isFolderOk=0 else isFolderOk=1
		)
		else
		isFolderOk = 0
	)
	return isFolderOk
)

-- 	Main function to send all the jobs. This is one of the most important function.
-- 	Too many things to comment, Ask me if you have questions, I hope I don't die before you have to edit this script, it would suck for me and you too...
fn SendToDeadline=
(
		vr = renderers.current
	setOutputPath()
	if (SchedulePm) then change_Schedule(true) else change_Schedule(false) 
				

	if (RenderMode=="Animation") then
	(
		if (engine == "vray") then
		(
			renderers.current.system_distributedRender = false
			case EngineMode of
			(
				 "LCIR":
				(
-- 					if (SchedulePm) then change_Schedule(true) else change_Schedule(false) 
					PrepareLightCacheJob_Anim()
	-- 						jobNameLC = SimpleDeadlineSubmitter_Rollout.edt_jobname.text + "_1_LC"
					result_lc = SubmitToDeadline jobNameLC false false isPrepass:true
					
					if (result_lc!="failed") then
					(
						Ui_report "The light cache was sent." color:"green"
						if (SchedulePm) then change_Schedule(false)
						PrepareIrradienceMapJob 10 1
	-- 							jobNameIM = SimpleDeadlineSubmitter_Rollout.edt_jobname.text + "_2_IM"
						result_irr = SubmitToDeadline jobNameIM true true isPrepass:true
						
						if (result_irr!="failed") then
						(
							Ui_report "The irradiance map was sent." color:"green"
							PrepareRenderScene 2
	-- 								jobName = SimpleDeadlineSubmitter_Rollout.edt_jobname.text + "_3_RENDER"
							result_final = SubmitToDeadline jobNameRender true false 
							if (result_final!="failed") then
							(
								Ui_report "The render was sent." color:"green"
								Ui_report "Todo bien!" color:"green"
							)else Ui_report "The render failed..." color:"red"
						)else Ui_report "The Irradiance map failed..." color:"red"
					)else Ui_report "The light cache failed..." color:"red"
				)

				 "LCIRMove":
				(
					
-- 					if (SchedulePm) then change_Schedule(true) else change_Schedule(false) 
					PrepareLightCacheJob_Anim()

					result_lc = SubmitToDeadline jobNameLC false false isPrepass:true
					
					if (result_lc!="failed") then
					(
						Ui_report "The light cache was sent." color:"green" 
						if (SchedulePm) then change_Schedule(false)
						PrepareIrradienceMapJob 1 6

						result_irr = SubmitToDeadline jobNameIM true false isPrepass:true
						
						if (result_irr!="failed") then
						(
							Ui_report "The irradiance map was sent." color:"green"
							PrepareRenderScene 7

							result_final = SubmitToDeadline jobNameRender true false 
							if (result_final!="failed") then
							(
								Ui_report "The render was sent." color:"green"
								Ui_report "Todo bien!" color:"green"
							)else Ui_report "The render failed..." color:"red"
						)else Ui_report "The Irradiance map failed..." color:"red"
					)else Ui_report "The light cache failed..." color:"red"
				)

				 "LCBF":
				(
-- 					if (SchedulePm) then change_Schedule(true) else change_Schedule(false) 
					PrepareLightCacheJob_Anim()
	
					result_lc = SubmitToDeadline jobNameLC false false isPrepass:true
					
					if (result_lc!="failed") then
					(
						Ui_report "The light cache was sent." color:"green"
						if (SchedulePm) then change_Schedule(false)
						PrepareRenderScene_BF()

						result_final=SubmitToDeadline jobNameRender true false 
						if (result_final!="failed") then
							(
								Ui_report "The render was sent." color:"green"
								Ui_report "Todo bien!" color:"green"
							)else Ui_report "The render failed... Fart noise..." color:"red"
					)else Ui_report "The light cache failed... Fart noise..." color:"red"
				)
				
				"NoGI":
				(
						rendTimeType = 2 -- Active Time Segment
						rendNthFrame = 1
						result_final=SubmitToDeadline jobNameRender false false batchGrouping:false
						if (result_final!="failed") then
							(
								Ui_report "The render was sent." color:"green"
								Ui_report "Todo bien!" color:"green"
							)else Ui_report "The render failed... Fart noise..." color:"red"
					
					--if(isGI == true) then renderers.current.gi_on = true
				)
		)
		)else if (engine == "corona") then
		(
			print CoronaEngineMode
-- 			foutre2
			renderers.current.gi_uhdcache_preset =1
			case (CoronaEngineMode) of
			(
				"direct":(
				
					
					rendTimeType = 2 -- Active Time Segment
					rendNthFrame = 1

					
					renderers.current.dr_enable=false
					SMTDSettings.DBR = false
					SMTDSettings.DBRUse3dsCmd = true
					cmdEnabled  = true
					setIniSetting SMTDPaths.IniFile "DBROptions"  "DBRUse3dsCmd" ((SMTDSettings.DBRUse3dsCmd = true) as string)

					result_final=SubmitToDeadline jobName false false batchGrouping:false
					if (result_final!="failed") then
				(
					Ui_report "The render was sent." color:"green"
					Ui_report "Todo bien!" color:"green"
				)else Ui_report "The render failed... Fart noise..." color:"red"
			
				)
				"UHDMultiple":(
					currentMaxRenderTime = vr.progressive_timeLimit
					rendTimeType = 2 -- Active Time Segment
					rendNthFrame = nThFrames
					vr.progressive_timeLimit =1000
					vr.gi_uhdCache_precalcMode =2
					vr.gi_uhdCache_file= (substring Output_Path 1 (Output_Path.count-4 )) + ".uhd"
				
					result_lc = SubmitToDeadline jobNameUHD false true isPrepass:true batchGrouping:true
					
					if (result_lc!="failed") then
					(
						Ui_report "The light cache was sent." color:"green"
						if (SchedulePm) then change_Schedule(false)
						rendNthFrame = 1
						vr.progressive_timeLimit = currentMaxRenderTime
						vr.gi_uhdCache_precalcMode =1
						vr.gi_uhdCache_file= (substring Output_Path 1 (Output_Path.count-4 )) + ".uhd"

						result_final=SubmitToDeadline jobNameRender true false 
						if (result_final!="failed") then
							(
								Ui_report "The render was sent." color:"green"
								Ui_report "Todo bien!" color:"green"
							)else Ui_report "The render failed... Fart noise..." color:"red"
					)else Ui_report "The light cache failed... Fart noise..." color:"red"	
				)
				"UHDSingle":(
					currentMaxRenderTime = vr.progressive_timeLimit
					rendTimeType = 1 -- Active Time Segment
					vr.progressive_timeLimit =1000
					vr.gi_uhdCache_precalcMode = 0
					vr.gi_uhdCache_file= (substring Output_Path 1 (Output_Path.count-4 )) + ".uhd"
					vr.gi_uhdCache_save = true
					result_lc = SubmitToDeadline jobNameUHD false true isPrepass:true batchGrouping:true
					
					if (result_lc!="failed") then
					(
						Ui_report "The light cache was sent." color:"green"
						if (SchedulePm) then change_Schedule(false)
						vr.gi_uhdCache_save = false
						rendTimeType = 2 -- Active Time Segment
						rendNthFrame = 1
						sliderTime = (animationRange.end - animationRange.start ) / 2
						
						
						
						vr.progressive_timeLimit = currentMaxRenderTime
						vr.gi_uhdCache_precalcMode =1
						vr.gi_uhdCache_file= (substring Output_Path 1 (Output_Path.count-4 )) + ".uhd"

						result_final=SubmitToDeadline jobNameRender true false 
						if (result_final!="failed") then
							(
								Ui_report "The render was sent." color:"green"
								Ui_report "Todo bien!" color:"green"
							)else Ui_report "The render failed... Fart noise..." color:"red"
					)else Ui_report "The light cache failed... Fart noise..." color:"red"	
				)
			)
		)
	)
	else
	(
			
-- 		foutre
		if (SubRolloutBETA_Rollout.chk_LC_Local.state) then
		(
			vr = renderers.current
			local primaryGI=vr.gi_primary_type

			vr.gi_primary_type  = 3
			vr.lightcache_switchToSavedMap = true
			vr.lightcache_autoSave  = true
			vr.lightcache_autoSaveFileName = SubRolloutBETA_Rollout.edt_LC_Local_Output.text
			
			actionMan.executeAction 0 "50031"  -- Render: Render
			
			vr.gi_primary_type  = 2
		)

			if (SchedulePm) then change_Schedule(true) else change_Schedule(false) 
			jobName = SimpleDeadlineSubmitter_Rollout.edt_jobname.text
			
			result_final = SubmitToDeadline_Rdr jobName isBatch:SimpleDeadlineSubmitter_Rollout.chk_batchname.state
			if (result_final!="failed") then
			(
				Ui_report "The render was sent." color:"green"
				Ui_report "Todo bien!" color:"green"
				if (SubRolloutBETA_Rollout.chk_LC_Local.state) then
				(
					vr.lightcache_switchToSavedMap = false
					vr.lightcache_autoSave  = false
					vr.lightcache_mode = 0
				)
			)else Ui_report "The render failed... Fart noise..." color:"red"

	)
	CleanUpSettings()
)

----------------------------------------------------------------------------------------------Sanity check functions--------------------------------------------------------------------------------------------------------------

fn CheckDynamicMemoryLimit =
(
	isMemoryDefault = false
	vr = renderers.current
	if (( getproperty renderers.current #system_raycaster_memLimit)== 4000) then
	isMemoryDefault = true
	return isMemoryDefault
 )

fn CheckForRenderElementFilePath =
(
	isFilePath = false
 	re = maxOps.GetCurRenderElementMgr()
	numb = re.numrenderelements() 
 
	for i=0 to (numb-1) do
	(
		print (re.GetRenderElementFileName i)
		el = re.getrenderelement i
		if ((re.GetRenderElementFileName i)!= undefined and (re.GetRenderElementFileName i)!="") then
		isFilePath = true
	)
	return isFilePath
)

fn CheckForVRayRegionRender =
(
	isRegion = false
	if (vrayVFBGetRegionEnabled()) then isRegion = true
	if ((getRenderType())!=#view) then isRegion = true
		return isRegion
)

fn CheckForVRayTrackMouse =
(
	vr = renderers.current
	if vr.output_on then
	(
		-- Function only available in V-Ray v3.0+ onwards
		return not (vfbControl(#trackmouse))[1] == 0
	)
	else return true					
)

fn CheckForXrefVisible =
(		
	nbrXref=xrefs.getXRefFileCount()
	isXrefHid=false	
	
	for i = 1 to nbrXref do
	(
		bXref = xrefs.getXRefFile i
		if (bXref.hidden and not bXref.disabled) then isXrefHid=true
	)
	return isXrefHid
)

fn CheckFoxUnresolvedXref =
(
	missing_xref = xrefs.findUnresolvedXRefs()
	if (missing_xref.count>0) then return true
	else return false
)
fn CheckFoxCameraLock =
(
	if (rendUseActiveView) then return false
	else return true
)

fn CheckForCameraNotMatchingName=
(	
	if(viewport.getCamera() != undefined) then
	(
-- 					print ImgOutputName
-- 			print (remove_range_from_cam (viewport.getCamera()).name)
		if (ImgOutputName == ((viewport.getCamera()).name)) then
		(

			return false
		)
		else
		(
			return true
		)
	)else
	(
	return false
	)
)

fn CheckForOutputExtension=
(
	local isExt = true

	for ext in list_extentions do
	(
			if ((findString Output_Path ext)!=undefined) then isExt = false
	)
	
	return isExt
)

fn CheckForOutputLocal=
(
	thePath = rendOutputFilename
	--print thePath
	--print (findString thePath "C:\\")
	if ((findString thePath "C:\\")==undefined) then return false
	else return true
)

fn CheckForRenderMask=
(
	vr = renderers.current
	isBucket = false
	
	if vr.imageSampler_renderMask_type != 0 then isBucket = true
		return isBucket
)
	



----------------------------------------------------------------------------------------------Sanity check functions--------------------------------------------------------------------------------------------------------------


-- Sanity check function
fn sanity_check_vray =
(
	isSane = true
	initReportWindow()

	if (CheckForVRayTrackMouse()) then (
		Ui_report "Track Mouse while rendering is on." color:"red" AddTimeStamp:false addText:"FATAL ERROR: EC0" 
		isSane = false
		)
	if (CheckForVRayRegionRender()) then (
		Ui_report "Region render is on." color:"orange" AddTimeStamp:false addText:"WARNING: EC1"
		isSane = false
	)
	if (CheckForXrefVisible()) then (
		Ui_report "Some of your XREF are not visible, they won't render." color:"red" AddTimeStamp:false addText:"WARNING: EC2"
		isSane = false
	)
	if (CheckFoxUnresolvedXref()) then (
		Ui_report "The camera lock is on. Might render the wrong camera." color:"red" AddTimeStamp:false addText:"WARNING: EC3"
		isSane = false
	)
	if (CheckForCameraNotMatchingName()) then
	(
		Ui_report "Did you click on update? The output camera is different than the current camera" color:"red" AddTimeStamp:false addText:"WARNING: EC4"
		isSane = false
	)
	

	if (CheckForOutputExtension()) then
	(
		Ui_report "caca" color:"red" AddTimeStamp:false addText:"WARNING: EC5"
		isSane = false
	)
	if (CheckForOutputLocal()) then
	(
		Ui_report "Your default output file is set to a local drive. Your render will not render..." color:"red" AddTimeStamp:false addText:"FATAL ERROR: EC6"
		isSane = false
	)
	if(CheckForRenderMask()) then
	(
		Ui_report "You have a Rendermask on!" color:"red" Addtimestamp:false addText:"WARNING: EC7"
	)
	if(CheckFoxCameraLock())then
	(
		Ui_report "Camera lock is on. Might not render the right camera." color:"red" AddTimeStamp:false addText:"FATAL ERROR: EC8"
		isSane = false
	)
	if (CheckForRenderElementFilePath()) then (
	Ui_report "You have a file path in your render element." color:"red" AddTimeStamp:false addText:"FATAL ERROR: EC9" 
	isSane = false
	)
	
	if (CheckDynamicMemoryLimit()) then (
	Ui_report "Dyn mem. limit set to 4000. Recommended 28000." color:"red" AddTimeStamp:false addText:"FATAL ERROR: EC10" 
	isSane = false
	)
	
-- 		if outputpathname <> current camera name
	if isSane then Ui_report "All good! Your file passed the sanity check!" color:"green"
	else
	Ui_report "Right Click on the problem and it will fix itself!!" color:"green" AddTimeStamp:false addText:"Fix it"
	return isSane
)

-- Sanity check function for corona
fn sanity_check_corona =
(
		if (CheckForXrefVisible()) then (
		Ui_report "Some of your XREF are not visible, they won't render." color:"red" AddTimeStamp:false addText:"WARNING: EC2"
		isSane = false
	)
	if(CheckFoxCameraLock())then
	(
		Ui_report "Camera lock is on. Might not render the right camera." color:"red" AddTimeStamp:false addText:"FATAL ERROR: EC8"
		isSane = false
	)
	
		if (CheckFoxUnresolvedXref()) then (
		Ui_report "The camera lock is on. Might render the wrong camera." color:"red" AddTimeStamp:false addText:"WARNING: EC3"
		isSane = false
	)
	if (CheckForCameraNotMatchingName()) then
	(
		Ui_report "Did you click on update? The output camera is different than the current camera" color:"red" AddTimeStamp:false addText:"WARNING: EC4"
		isSane = false
	)
	

	if (CheckForOutputExtension()) then
	(
		Ui_report "caca" color:"red" AddTimeStamp:false addText:"WARNING: EC5"
		isSane = false
	)
	if (CheckForOutputLocal()) then
	(
		Ui_report "Your default output file is set to a local drive. Your render will not render..." color:"red" AddTimeStamp:false addText:"FATAL ERROR: EC6"
		isSane = false
	)
	if (CheckForRenderElementFilePath()) then (
	Ui_report "You have a file path in your render element." color:"red" AddTimeStamp:false addText:"FATAL ERROR: EC9" 
	isSane = false
	)
	

	
	
	
	
	local isSane = true
	if isSane then Ui_report "All good! Your file passed the sanity check!" color:"green"
	else
	Ui_report "Right Click on the problem and it will fix itself!!" color:"green" AddTimeStamp:false addText:"Fix it"
	return isSane
)

-- Sanity check function - fix
fn fixSanity errorCode =
(
	case errorCode of
	(
		("FATAL ERROR: EC0"): 
		(
			vr = renderers.current
			vfbControl(#trackmouse) false
		)
		
		("WARNING: EC1"): 
		(
			vrayVFBSetRegionEnabled(false)
			setRenderType(#view)
		)
		
		("WARNING: EC2"): 
		(
			nbrXref=xrefs.getXRefFileCount()
			for i = 1 to nbrXref do
			(
				bXref = xrefs.getXRefFile i
				if (bXref.hidden) then bXref.hidden = false
			)
		)
		
		("WARNING: EC3"): 
		(
			if querybox "Some of your xref's are missing - please relink or remove them before submitting your job!" beep: true then
				(actionMan.executeAction 0 "40368")
		)
		
		("WARNING: EC4"): 
		(
			if queryBox  "Do you want to change to the output camera" title: "WARNING: Camera Path issue: EC04" beep: true then 
			(SimpleDeadlineSubmitter_Rollout.btn_update.pressed())
		)
		
		("WARNING: EC5"): 
		(
			if queryBox "You didn't specify an extension for your output. Do you want to fix this now?" beep: true then
			(SimpleDeadlineSubmitter_Rollout.btn_OutputSave.pressed())
		)
		
		("FATAL ERROR: EC6"): 
		(
			renderSceneDialog.close()
			rendOutputFilename =""
		)

		("WARNING: EC7"):
		(
			vr = renderers.current
			vr.imageSampler_renderMask_type = 0
		)
		
		("FATAL ERROR: EC8"): 
		(
			rendUseActiveView = true	
		)		
		
		("FATAL ERROR: EC9"): 
		(
			re = maxOps.GetCurRenderElementMgr()
			numb = re.numrenderelements() 
		 
			for i=0 to (numb-1) do
			(
				el = re.getrenderelement i
				if ((re.GetRenderElementFileName i)!= undefined and (re.GetRenderElementFileName i)!= "") then
				re.setRenderElementFileName i ""
			)
		)		
		("FATAL ERROR: EC10"): 
		(
			renderers.current.system_raycaster_memLimit = 28000
		)	
	)
)

fn submit=
(	

	
-- 		Sanity checks the file
		local isSane=true
		if(VFBTabs.chk_performSanityCheck.checked) then 
		(
			if(engine=="vray") then isSane = sanity_check_vray()
			if(engine=="corona") then isSane = sanity_check_corona()
		)
-- 		If the file is sane, then we try to render
		if (isSane)	then 
		(
			if (engine=="vray") then initiate_vfb_save()
			renderSceneDialog.close()
-- 			We make sue the output path can be created. If it works we then submit the job to DEadline
			folderOk = PathCheck()
			if (folderOk == 1) then Ui_report "The folder doesn't exist and couldn't be created, please double check the path" clearLv:true color:"red" AddTimeStamp:false
			if (folderOk == 2) then Ui_report "You're trying to save on a local drive, not good...Change the path" clearLv:true color:"red" AddTimeStamp:false
			if (folderOk == 0) then SendToDeadline()
		)

)


stillBatchName = getProjectName()
todayDate = getDateToday()
SMTDSettings.SubmitSceneMode = #reposave
setIniSetting SMTDPaths.InIFile "UserOptions"  "SubmitSceneMode"  (SMTDSettings.SubmitSceneMode as string)
SMTDSettings.UserName = SMTDFunctions.GetDeadlineUser()
if((findString (renderers.current as string) "V_Ray_Adv" )!=undefined) then engine="vray"
if((findString (renderers.current as string) "Corona" )!=undefined) then engine="corona"

rollout SubRolloutBatchRender "Batch Render" rolledup:true
(
	
	radiobuttons maxPxRadio labels:#("1500px","2500px","5000px") across:2 align:#left
	checkbox updateRatio "Automatically update camera ratio"  align:#right
	
	multiListBox mlb "Camera List" width:420 height:20
-- 	button btn_batch_rdr "Render Sel Cam" align:#right 
	
	on maxPxRadio changed state do
	(
		--need to declare maxPx
		maxPx = case state of (
		1: 1500
		2: 2500
		3: 5000)
	)
	on SubRolloutBatchRender open do
	(
		cameraSorted=#()
		for cam in cameras do
		(
			if ((findString cam.name ".Target" )==undefined) then
			(
				append cameraSorted cam.name
			)
		)
		
		cameraSorted = sort cameraSorted
			--print cameraSorted
		for camName in cameraSorted do
		(
				append cameraList camName
			cam = getnodebyname camName
				keyFrames = getKeyFrames cam
				mlb.items = append mlb.items (camName + " " + "(" + keyFrames[1] as string + "-" + keyFrames[2] as string + ")")
		)
	)
	on SubRolloutBatchRender rolledup state do
	(
		 mlb.selection = #()
	)

)




rollout  SubRolloutEngineAnimationCorona_Rollout "Animation Corona"
(
	radiobuttons chk_CoronaAnimType labels:#("Direct", "Precalc UHD Single","Precalc UHD Multiple")  height:40 width:90 checked:true align:#left across:3

 	label lbl_frames "Render every Nth Frame" align:#left enabled:false
 	spinner frames "" range:[1,200,nThFrames] type:#integer fieldwidth:50 align:#left enabled:false

	on chk_CoronaAnimType changed state do 
	(
		if (state==3) then
		(
			lbl_frames.enabled = true
			frames.enabled = true
			CoronaEngineMode = "UHDMultiple"
		)
		if (state==2) then
		(
			lbl_frames.enabled = false
			frames.enabled = false
			CoronaEngineMode = "UHDSingle"
		)
		if (state==1) then
		(
			lbl_frames.enabled = false
			frames.enabled = false
			CoronaEngineMode = "Direct"
		)
	)
	
		on frames changed val do
	(
		nThFrames = val		
	)
)





rollout  SubRolloutEngineAnimationVray_Rollout "Animation Vray"
(
	checkbox chk_LCIR "LC + IR\n(Non moving object)" across:4 height:50 width:100
	checkbox chk_LCIRMove "LC + IR\n(moving\nobject)" height:50 width:90 offset:[30,0] 
		
	checkbox chk_LCBF "LC + BF\n(moving\nobject)" height:50 width:90 offset:[30,0] checked:true
	checkbox chk_noGI "Straight" height:40 width:90 offset:[30,0]
	label lbl_frames "Render every Nth Frame" align:#left
	spinner frames "" range:[1,15,10 ] type:#integer fieldwidth:50 align:#left
	
	on chk_noGI changed state do
	(
		if state then
		(
			--"CACA"
			EngineMode="NoGI"
			chk_LCIR.checked = false
			chk_LCBF.checked = false
			chk_LCIRMove.checked = false
			frames.enabled = false
		)
		else
			chk_noGI.checked = not (chk_LCIR.checked or chk_LCBF.checked or chk_LCIRMove.checked)
	)
	
	
	on chk_LCIRMove changed state do
	(
		if state then
		(
			EngineMode="LCIRMove"
			chk_LCIR.checked = false
			chk_LCBF.checked = false
			chk_noGI.checked = false
			frames.enabled = false
		)
		else
			chk_LCIRMove.checked = not (chk_LCIR.checked or chk_LCBF.checked or chk_noGI.checked)
	)
	on chk_LCIR changed state do
	(
		if state then
		(
			EngineMode="LCIR"
			chk_LCIRMove.checked = false
			chk_LCBF.checked = false
			chk_noGI.checked = false
			frames.enabled = true
		)
		else
			chk_LCIR.checked = not (chk_LCIRMove.checked or chk_LCBF.checked or chk_noGI.checked)
	)

	on chk_LCBF changed state do
	(
		if state then
		(
			EngineMode="LCBF"
			chk_LCIR.checked = false
			chk_LCIRMove.checked = false
			chk_noGI.checked = false
			frames.enabled = false
		)
		else
			chk_LCBF.checked = not (chk_LCIRMove.checked or chk_LCIR.checked or chk_noGI.checked)
	)
	on frames changed val do
	(
		rendNthFrame = val		
	)
)


-- Animation rollout
rollout  SubRolloutEngineAnimation_Rollout "Animation"
(
	checkbox chk_setFrameAuto "Set Frame Range From Camera Name" tooltip:"This only works if your cameras are named properly. If camera 'Entrance_fe120_' then the end frame will be 120. If camera 'Entrance_fs50_fe120_ then auto range = 50-120" align:#left checked:false across:3
	edittext edt_InFrame "From" fieldwidth:40  align:#right 
	edittext edt_OutFrame "To" fieldwidth:40  align:#right 
	

	
	on SubRolloutEngineAnimation_Rollout open do
	(
		edt_InFrame.text = (animationRange.start as string)
		edt_OutFrame.text = (animationRange.end as string)
	)
	
	on chk_setFrameAuto changed theState do
	(
		 if theState then
		(
			 edt_InFrame.enabled = false 
			 edt_OutFrame.enabled=false
			SimpleDeadlineSubmitter_Rollout.btn_update.pressed()
		 )
		 else
		 (
			 edt_InFrame.enabled = true
			 edt_OutFrame.enabled=true
		 )
	)	
	on edt_InFrame entered txt do
	(
		setAnimationRange2 SubRolloutEngineAnimation_Rollout.chk_setFrameAuto.checked txt animationRange.end
	)

	on edt_OutFrame entered txt do
	(
		setAnimationRange2 SubRolloutEngineAnimation_Rollout.chk_setFrameAuto.checked animationRange.start txt
	)
	
	
	
	
)

-- Stills rollout
rollout  SubRolloutEngineStill_Rollout "Still"
(
spinner spn_nb_spawner "How many blades do you need ?" range:[0,100,10] type:#integer fieldwidth:50 
	
	on spn_nb_spawner changed val do
	(
		nbr_spawn = SubRolloutEngineStill_Rollout.spn_nb_spawner.value	
	)
	
	on chk_LCIR changed state do
	(
		if state then
		(
			EngineMode="LCIR"
			chk_LCBF.checked = false
		)
		else
			chk_LCIR.checked = not chk_LCIR.checked
	)
	
	on chk_LCBF changed state do
	(
		if state then
		(
			EngineMode="LCBF"
			chk_LCIR.checked = false
		)
		else
			chk_LCBF.checked = not chk_LCBF.checked		
	)
)


	
	-- Main rollout
		
rollout SimpleDeadlineSubmitter_Rollout "Main Options"
(
	label lbl_OutputFile "Output File:" width:60 height:20 align:#left across:4
	button btn_update "Update" width:50 height:20  align:#left offset:[-40,0]
	button btn_OutputSave "..." width:20 height:20 offset:[-95,0] align:#left
	button btn_OutputSavePlus "+" width:20 height:20 offset:[-180,0] align:#left
	edittext edt_OutputFile "" fieldwidth:430  align:#right
	
	edittext edt_SubPath  "SubFolder" tooltip:"Add the name of the subfolder you'd like the images to be saved in." fieldwidth:100 across:2
	radiobuttons SubFolderPlace labels:#("Before date", "After date") offset:[-80,0]
	
	label lbl_help_jobname "Job Name:" width:60 height:20 across:2 align:#left  tooltip:"The Job Name text field is populated automatically using the 3ds Max scene file name.\n\nYou can also use the [>>] button to set the text to symbolic names to be replaced with the respective value at submission time." border:false
	edittext edt_jobname "" fieldwidth:370 align:#right 
	checkbox chk_batchname align:#left checked:false across:3 
	label lbl_help_batchname "Batch Name:" width:100 height:20 align:#left  tooltip:"Will create groups in Deadline. Good in order to keep your projects together and organized." border:false offset:[-120,0] ENABLED:FALSE
	edittext edt_batchname "" fieldwidth:340 align:#right ENABLED:FALSE
	label btn_group_help "Group: " align:#left across:2 width:60 height:20 border:false tooltip:"The GROUP lets you limit the job to only specific machines, typically based on hardware or installed software characteristics.\n\nSelect the 'none' Group to turn off Group filtering."
		
	dropdownlist ddl_group items:#() align:#right width:390 height:20 tooltip:"The GROUP lets you limit the job to only specific machines, typically based on hardware or installed software characteristics.\n\nSelect the 'none' Group to turn off Group filtering."
	
	checkbox chk_beauty_tif "TIF" align:#left  across:5 
	checkbox chk_beauty_exr "EXR/CXR"  offset:[-40,0] align:#left checked:true
	checkbox chk_alpha_pass "Alpha"  offset:[-80,0] align:#left
	checkbox chk_rdr_elm "Rdr Elements" offset:[-110,0] align:#left
	
	
	spinner spn_priority "Priority:" range:[1,100,SMTDSettings.Priority] type:#integer fieldwidth:50
	
	checkbox chk_Schedule_Pm "Start after hours.(7pm)" tooltip:"The render will only start at 7pm." align:#left checked:true across:4
	checkbox chk_merge_XREF "Merge XREF" tooltip:"Useful for scenes that don't render without merging XREF. Don't use it if you don't know what you're doing!!!" align:#left checked:false offset:[40,0]
	checkbox chk_simult_blades tooltip:"Maximum number of frames that will render simultenaously. Good if you want to render an animation during the day without blocking all the blades." align:#right checked:false offset:[-40,0] enabled:false
	spinner spn_simult_blades "Max simult. frames:" tooltip:"Maximum number of frames that will render simultenaously. Good if you want to render an animation during the day without blocking all the blades." range:[1,250,12] type:#integer   align:#right enabled:false
	
	
	
	on edt_batchname entered txt do
	(
		stillBatchName = txt
		
	)
	on SubFolderPlace changed state do(
		setBaseOutputPath()
		update_output_path_Job_Name()
	)
	
	on chk_rdr_elm changed state do(
		local reMgr = maxOps.getCurRenderElementMgr()
		reMgr.SetElementsActive state
	)
	
	on chk_beauty_exr changed state do(
		if (engine=="corona") then
		(
			chk_beauty_tif.checked = not state
		)

	)
	
	on chk_beauty_tif changed state do(

		if (engine=="corona") then
		(
			chk_beauty_exr.checked = not state
		)
	)
	
		on chk_alpha_pass changed state do(

		renderers.current.output_splitAlpha = state
	)

	on edt_SubPath entered txt do(
		subFolderMain = txt
		setBaseOutputPath()
	update_output_path_Job_Name()
	)
	
	on chk_simult_blades changed state do
	(
		spn_simult_blades.enabled = state
		Ui_report ("+Job Options: Machine Limit State set to [" + state as string + "]") 
	)

	on spn_simult_blades changed value do 
	(
	
		Ui_report ("+Job Options: Machine Limit Count set to [" + value as string + "]") 
	)	
	
	on chk_batchname changed state do
	(
		lbl_help_batchname.enabled = state
		edt_batchname.enabled = state
		if (state) then SimpleDeadlineSubmitter_Rollout.edt_batchname.text = stillBatchName
	)
	
	on chk_merge_XREF changed state do
	(
		SMTDSettings.MergeSceneXRefsOnSubmission = state
	)		
	
	on btn_update pressed do
	(
		
		if (RenderMode=="Animation") then
		setAnimationRange2 SubRolloutEngineAnimation_Rollout.chk_setFrameAuto.checked animationRange.start animationRange.end
		
		update_output_path_Job_Name()
	) 	

	on btn_OutputSavePlus pressed do
	(
		local outputEdit =""
		outputTemp = filterString edt_OutputFile.text "_"
		last_thing = (outputTemp.count) - 1
		outputNbr = outputTemp[last_thing] as integer
		if (outputNbr!=undefined) then
		(
			i=1
			while i<=outputTemp.count do
			(
				if (i!=outputTemp.count) then
				(
					if (i==(outputTemp.count - 1)) then
						(
							outputTemp[i] = outputTemp[i] as integer + 1
							outputTemp[i] = outputTemp[i] as string
							if (outputTemp[i].count==1) then outputTemp[i] = "0" + outputTemp[i]
						)
						
				outputEdit += outputTemp[i] as string + "_"
				)
				else
				outputEdit += outputTemp[i]
				i=i+1
			)
		)
		else
		(
			i=1
			while i<=outputTemp.count do
			(
				if (i!=outputTemp.count) then
				(
				outputEdit += outputTemp[i] as string + "_"
					if (i==(outputTemp.count - 1)) then
					(
							outputEdit += "01_"
					)
				)
				else
				outputEdit += outputTemp[i]
				i=i+1
			)
			)
		edt_OutputFile.text = outputEdit
		
	)



	on spn_priority changed val do
	(
		SMTDSettings.Priority = val
	)

	on chk_Schedule_Pm changed theState do
	(
		SchedulePm = theState
	)


	on SimpleDeadlineSubmitter_Rollout open do
	(

		SMTDFunctions.CollectGroups()
		ddl_group.items = SMTDSettings.Groups
		change_schedule(true)
		
		local theIndex = findItem ddl_group.items SMTDSettings.Group
		if theIndex > 0 then 
			ddl_group.selection = theIndex 
		else
		(
			theIndex = findItem ddl_group.items "none"
			if theIndex > 0 do
			(
				ddl_group.selection = theIndex 
				SMTDSettings.Group = "none"
			)
		)
		rendNthFrame = 1
		
		local reMgr = maxOps.getCurRenderElementMgr()
		chk_rdr_elm.checked= reMgr.GetElementsActive()
		
		if (engine=="vray") then
		(
			chk_beauty_tif.checked=renderers.current.output_splitRGB
			chk_alpha_pass.checked=renderers.current.output_splitAlpha
		)
		----- CACA
		if (engine=="corona") then
		(
			
			chk_alpha_pass.visible=false
		)
	)

	on SimpleDeadlineSubmitter_Rollout close do()

	on edt_jobname entered txt do 
	(
		setIniSetting SMTDPaths.InIFile "JobSettings"  "jobName"  (SMTDSettings.jobName = txt)
		
	)
	
	on btn_OutputSave pressed do
	(
		local newPath = getSaveFileName caption:"Output file" \
						filename:edt_OutputFile.text \
						types:"TIFF (*.tif)|*.tif" 
		if(newPath != undefined) do
		(
			edt_OutputFile.text = newPath
-- 		setJobName newPath 		
			
		)
	)
	
	on edt_OutputFile entered txt do
	(
	----------- hyper caca
		updateJobNamefromOutputPath()
	)

	on ddl_group selected itm do 
	(
		setIniSetting SMTDPaths.InIFile "JobSettings"  "Group" ( (SMTDSettings.Group = ddl_group.selected) as string )
	)
		
	
	

)

--Main UI with Tabs
rollout VFBTabs ("Norm Li Deadline Submitter V" + softwareVersion )
(
	dotNetControl dn_tabs "System.Windows.Forms.TabControl" height:20 width:200 align:#left
	subRollout theSubRollout  height:440 align:#center
	checkbox chk_performSanityCheck "Sanity Check Me Before Submission" align:#left checked:true across:3
	button btn_runSanityCheck "Sanity Check Me!" align:#right width:120 height:20 tooltip:"Run Sanity Check WITHOUT submitting the scene to Deadline." offset:[30,0] 
	button btn_submit "RENDER" width:120 height:20 align:#right
	dotNetControl lv "system.windows.forms.listView" height:100
	
	on lv MouseClick itm do
	(
		if itm.Button.Equals itm.Button.right then
		(
			for i in 0 to lv.Items.count-1 do
			(
				li = lv.Items.item[i]
				if li.selected then
				(
					fixSanity li.SubItems.item[0].text
				)
			)
			
			btn_runSanityCheck.pressed()
		)
	)
	
		
		
		
		
		
		
		
	on btn_runSanityCheck pressed do
	(
		if(engine=="vray") then isSane = sanity_check_vray()
		if(engine=="corona") then isSane = sanity_check_corona()
	)
	
	on dn_tabs Selected itm do
	(
		
		if itm.TabPageIndex==0 then 
		(
-- 			Prep the rollout
			RenderMode = "Still"
			removeSubRollout theSubRollout SubRolloutEngineAnimation_Rollout
			if (engine=="vray") then removeSubRollout theSubRollout SubRolloutEngineAnimationVray_Rollout
			if (engine=="corona") then removeSubRollout theSubRollout SubRolloutEngineAnimationCorona_Rollout

			addSubRollout theSubRollout SubRolloutEngineStill_Rollout
			addSubRollout theSubRollout SubRolloutBETA_Rollout

-- 			Do some adjustments to the rollout
			SimpleDeadlineSubmitter_Rollout.chk_batchname.enabled = true
			SimpleDeadlineSubmitter_Rollout.chk_simult_blades.enabled = false
			SimpleDeadlineSubmitter_Rollout.spn_simult_blades.enabled = false
			SimpleDeadlineSubmitter_Rollout.chk_simult_blades.checked = false
			
			
-- 			Set the outputpath and job name
			update_output_path_Job_Name()
			Ui_report "You are now in stills mode." clearLv:true
		)
		if itm.TabPageIndex==1 then 
		(
			
-- 			Prep the rollout
			RenderMode = "Animation"
			removeSubRollout theSubRollout SubRolloutEngineStill_Rollout
			removeSubRollout theSubRollout SubRolloutBETA_Rollout
			addSubRollout theSubRollout SubRolloutEngineAnimation_Rollout
			if (engine=="vray") then addSubRollout theSubRollout SubRolloutEngineAnimationVray_Rollout
			if (engine=="corona") then addSubRollout theSubRollout SubRolloutEngineAnimationCorona_Rollout


-- 			Do some adjustments to the rollout
			SimpleDeadlineSubmitter_Rollout.chk_batchname.checked =false
			SimpleDeadlineSubmitter_Rollout.chk_batchname.enabled = false
			SimpleDeadlineSubmitter_Rollout.lbl_help_batchname.enabled = false
			SimpleDeadlineSubmitter_Rollout.edt_batchname.enabled = false
			SimpleDeadlineSubmitter_Rollout.chk_simult_blades.enabled = true
			
-- 			Set the outputpath and job name
			update_output_path_Job_Name()
			Ui_report "You are now in animation mode." clearLv:true
		)

	)

	on VFBTabs open do
	(
-- 		Initiate the listview report thingy
		setBaseOutputPath()
		if (engine=="vray") then settingsDBR = renderers.current.system_distributedRender
		
		
		dnc_report = lv
		initReportWindow()
		Ui_report "Welcome! Have fun with the script!"
		Ui_report "You are now in stills mode."
-- 		Check that the file has been saved somewhere, if not, you can't send things to Deadline with the script
		if(maxfilename=="") then
		(
			messageBox("You need to save your file in order to use the script...")
			DestroyDialog VFBTabs
		)
		else
		(
			
			for aTab in VFBTabs_Rollouts do
			(
				dn_tabs.TabPages.add aTab[1]
			)
			addSubRollout theSubRollout SimpleDeadlineSubmitter_Rollout
			addSubRollout theSubRollout SubRolloutBatchRender
			addSubRollout theSubRollout SubRolloutEngineStill_Rollout
			addSubRollout theSubRollout SubRolloutBETA_Rollout
			SimpleDeadlineSubmitter_Rollout.edt_batchname.text = stillBatchName
-- 			Set the outputpath and job name
			update_output_path_Job_Name()
		)
	)
	
	on btn_submit pressed do
	(
		i = 0
		for cam in SubRolloutBatchRender.mlb.selection do
		(
			i=i+1
		)

-- 		SubRolloutBatchRender.mlb.selection 
		
		if (i== 0) then
			submit()
		else
		(
			SubRolloutEngineAnimation_Rollout.chk_setFrameAuto.checked = true
			for cam in SubRolloutBatchRender.mlb.selection do
			(
			--------------Christophe
			currCamera = getnodebyname cameraList[cam]
			viewport.setCamera (currCamera)
			if (SubRolloutBatchRender.updateRatio.checked) then resizeViewport currCamera maxPx
				--viewport.setCamera (getnodebyname cameraList[cam])
				SimpleDeadlineSubmitter_Rollout.btn_update.pressed()
				submit()
			--------------Christophe
				)
			
		)
		
		
		
		

-- 		SimpleDeadlineSubmitter_Rollout.chk_setFrameAuto.checked = true
-- 		for cam in mlb.selection do
-- 		(
-- 			viewport.setCamera (getnodebyname cameraList[cam])
-- 			SimpleDeadlineSubmitter_Rollout.btn_update.pressed()
-- 			VFBTabs.btn_submit.pressed()
-- 		
	)
)


 createDialog VFBTabs 490 610
)